import org.apache.cocoon.acting.AbstractAction;
import org.apache.cocoon.environment.Redirector;
import org.apache.cocoon.environment.SourceResolver;
import org.apache.cocoon.environment.Request;
import org.apache.cocoon.Constants;
import org.apache.cocoon.acting.RequestParamAction;
import org.apache.avalon.framework.parameters.Parameters;

import java.util.Map;
import java.util.HashMap;
import java.util.Enumeration;

/*
  Put this compiled file to 
  $tomcat/webapps/cocoon/WEB-INF/classes/MyRequestAction.class
 */
public class MyRequestAction extends RequestParamAction {

    public final static String MAP_URI         = "requestURI";
    public final static String MAP_QUERY       = "requestQuery";
    public final static String MAP_CONTEXTPATH = "context";
 
    public final static String PARAM_PARAMETERS = "parameters";
    public final static String PARAM_DEFAULT_PREFIX = "default.";


    public Map act( Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters param )
        throws Exception
    {

	// just a cut and paste from RequestParamAction
        Request request = (Request) objectModel.get(Constants.REQUEST_OBJECT);
        if (request == null) {
          getLogger().error("RequestInfoAction: no request object!");
          return(null);
        }
 
        Map map = new HashMap();

	// create a new session id if we do not already have one
	// and add it to map, so it can be requested from sitemap
	request.getSession();
        map.put("session-id", request.getSession(false).getId());
 
        map.put(MAP_URI, request.getRequestURI());
 
        String query = request.getQueryString();
        if (query != null && query.length() > 0){
          map.put(MAP_QUERY, "?" + query);
        }
        else{
          map.put(MAP_QUERY, "");
        }
 
        map.put(MAP_CONTEXTPATH, request.getContextPath());
 
        if ("true".equalsIgnoreCase(param.getParameter(PARAM_PARAMETERS, null))){
          Enumeration e = request.getParameterNames();
          while(e.hasMoreElements()){
            String name = (String) e.nextElement();
            String value = request.getParameter(name);

            if (value != null && !map.containsKey(name)){
              map.put(name, value);
            }
          }
	  
	  String[] paramNames = param.getNames();
          for (int i=0; i< paramNames.length; i++) {
	      if (paramNames[i].startsWith(PARAM_DEFAULT_PREFIX) &&
		  (request.getParameter(paramNames[i].substring(PARAM_DEFAULT_PREFIX.length())) == null)) {
		  map.put(paramNames[i].substring(PARAM_DEFAULT_PREFIX.length()), param.getParameter(paramNames[i]));
	      }
	  }


        }
 
        return(map);
    }

    
}
